// Generated by CoffeeScript 1.12.4
(function() {
  var _, aggregate, clone, digit, mask, name, normalize, type, typeNames, types;

  _ = require('lodash');

  normalize = require('./normalize');

  aggregate = require('./aggregate');

  types = require('./types');

  digit = /^\d+$/;

  module.exports.names = typeNames = Object.keys(types);

  for (name in types) {
    type = types[name];
    module.exports[name] = type;
  }

  module.exports.normalize = normalize;

  module.exports.aggregate = aggregate;

  module.exports.parse = function(name, value, req) {
    var fieldType, ref;
    if (typeNames.indexOf(name) !== -1) {
      fieldType = module.exports[name];
    }
    if ((fieldType != null) && (value != null)) {
      if (((ref = fieldType.components) != null ? ref.length : void 0) && (value.valid != null)) {
        return value;
      } else {
        return fieldType.parse(value, req);
      }
    } else {
      return value;
    }
  };

  module.exports.mask = mask = function(obj, doMask) {
    var key, str, value;
    if (doMask == null) {
      doMask = false;
    }
    if (obj == null) {
      return obj;
    }
    if (obj instanceof Array) {
      obj = obj.map(function(i) {
        return mask(i, doMask);
      });
    } else if (typeof obj === 'object') {
      if (obj.masked === false && (obj instanceof String || obj instanceof Boolean || obj instanceof Number || obj instanceof Date)) {
        str = new String(mask(obj.toString(), true));
        for (key in obj) {
          value = obj[key];
          if (key === 'valid') {
            str[key] = value;
          } else {
            if (!key.match(digit)) {
              str[key] = mask(value, true);
            }
          }
        }
        str.masked = true;
        obj = str;
      } else {
        for (key in obj) {
          value = obj[key];
          if (key === 'valid') {
            continue;
          }
          obj[key] = mask(value, (obj.masked != null) || doMask);
        }
        if (obj.masked != null) {
          obj.masked = true;
        }
      }
    } else if (_.isString(obj) || _.isNumber(obj) || _.isDate(obj)) {
      if (doMask) {
        obj = obj.toString().replace(/./g, '*');
      }
    } else if (_.isBoolean(obj)) {
      if (doMask) {
        obj = '*';
      }
    } else if (_.isFunction(obj)) {
      void 0;
    } else {
      throw "Don't know how to mask " + obj;
    }
    return obj;
  };

  clone = function(vars) {
    var obj, str, value;
    if (_.isArray(vars)) {
      return vars.map(function(v) {
        return clone(v);
      });
    } else if (vars instanceof String) {
      str = new String(vars.toString());
      for (name in vars) {
        value = vars[name];
        if (!name.match(digit)) {
          str[name] = value;
        }
      }
      return str;
    } else if (vars instanceof Number || vars instanceof Boolean || vars instanceof Date) {
      obj = new vars.constructor(vars.valueOf());
      for (name in vars) {
        value = vars[name];
        obj[name] = value;
      }
      return obj;
    } else if (_.isNumber(vars) || _.isBoolean(vars)) {
      return vars.valueOf();
    } else if (_.isDate(vars)) {
      return new Date(vars.getTime());
    } else if (_.isFunction(vars)) {
      return vars;
    } else if (vars instanceof Object) {
      obj = {};
      for (name in vars) {
        value = vars[name];
        obj[name] = clone(value);
      }
      return obj;
    } else {
      return vars;
    }
  };

  module.exports.clone = clone;

  module.exports.isValid = function(value) {
    if (!_.isPlainObject(value)) {
      return true;
    }
  };

  module.exports.expandExamples = function(field) {
    var ref;
    if (!field.type) {
      return field;
    }
    if (!((ref = field.examples) != null ? ref.length : void 0)) {
      return field;
    }
    field.examples = _.compact(field.examples.map(function(example) {
      var ref1, str;
      if (field.type === 'string') {
        return example;
      }
      str = (example != null ? example.raw : void 0) || example;
      if ((str != null ? str.trim : void 0) != null) {
        str = str != null ? str.trim() : void 0;
      }
      if (!str) {
        return example;
      }
      return normalize(((ref1 = module.exports[field.type]) != null ? ref1.parse(str) : void 0) || str);
    }));
    return field;
  };

}).call(this);
