// Generated by CoffeeScript 1.12.4
(function() {
  var _, components, formats, moment, normalize, parse;

  _ = require('lodash');

  moment = require('moment');

  normalize = require('../normalize');

  formats = ['ddd MMM DD YYYY', 'MMM DD YYYY', 'MM/DD/YYYY', 'YYYY-MM-DD', 'MM-DD-YYYY', 'MMDDYYYY'];

  parse = function(string, req) {
    var parsed, raw, ref, ref1, results;
    raw = (ref = string.raw) != null ? ref : string;
    results = moment(string.toString(), formats, true);
    if (!results.isValid()) {
      results = moment(string.toString(), formats);
      if (req != null) {
        if ((ref1 = req.logger) != null) {
          ref1.info("strict mode date-parsing failed for [" + string + "]; forgiving mode gave: " + (results.toString()));
        }
      }
    }
    if (results.isValid()) {
      parsed = results.toDate();
      parsed.raw = raw;
      parsed.valid = true;
      parsed.valueOf = function() {
        return this.toString();
      };
      parsed.toString = function() {
        return moment(this.getTime()).format('YYYY-MM-DD');
      };
    } else {
      parsed = new String(raw);
      parsed.raw = raw;
      parsed.valid = false;
    }
    return parsed;
  };

  components = [
    {
      name: 'raw',
      type: 'string',
      description: 'Unmodified value'
    }
  ];

  module.exports = {
    parse: parse,
    components: components,
    maskable: false,
    operators: ['is equal to', 'is not equal to', 'is less than', 'is less than or equal to', 'is greater than', 'is greater than or equal to', 'is blank', 'is not blank', 'format is valid', 'format is invalid', 'is between', 'is not between'],
    examples: ['Mon Jun 02 2014', 'Jun 02 2014', '06/02/2014', '2014-06-02'].map(parse).map(normalize)
  };

}).call(this);
