// Generated by CoffeeScript 1.12.4
(function() {
  var components, normalize, parse;

  normalize = require('../normalize');

  parse = function(string) {
    var gender, invalid, normalized, raw, ref;
    if (string == null) {
      return string;
    }
    raw = (ref = string.raw) != null ? ref : string;
    normalized = raw.toString().toLowerCase().trim();
    gender = (function() {
      switch (normalized) {
        case 'm':
        case 'male':
          return new String("male");
        case 'f':
        case 'female':
          return new String("female");
        case 'o':
        case 'other':
          return new String("other");
        default:
          invalid = new String(raw);
          invalid.valid = false;
          return invalid;
      }
    })();
    gender.raw = raw;
    if (gender.valid == null) {
      gender.valid = true;
    }
    gender.abbr = (function() {
      switch (gender.valueOf()) {
        case 'male':
          return 'M';
        case 'female':
          return 'F';
        case 'other':
          return 'O';
        default:
          return null;
      }
    })();
    return gender;
  };

  components = [
    {
      name: 'raw',
      type: 'string',
      description: 'Unmodified value'
    }, {
      name: 'abbr',
      type: 'string',
      description: 'Abbreviated name of gender'
    }
  ];

  module.exports = {
    parse: parse,
    components: components,
    maskable: false,
    operators: ['is equal to', 'is not equal to', 'is blank', 'is not blank', 'format is valid', 'format is invalid'],
    examples: ['male', 'female', 'other', 'M', 'F', 'O'].map(parse).map(normalize)
  };

}).call(this);
