// Generated by CoffeeScript 1.12.4
(function() {
  var _, normalize, parse, parseRegex;

  _ = require('lodash');

  normalize = require('../normalize');

  parseRegex = /^(\S+)\s+(.+)$/;

  parse = function(string) {
    var addr, parsed, ref, ref1;
    addr = string.trim().match(parseRegex);
    if (addr != null) {
      parsed = new String(string.trim());
      parsed.raw = (ref = string.raw) != null ? ref : string;
      parsed.number = addr[1];
      parsed.name = addr[2];
      parsed.valid = true;
    } else {
      parsed = new String(string);
      parsed.raw = (ref1 = string.raw) != null ? ref1 : string;
      parsed.valid = false;
    }
    return parsed;
  };

  module.exports = {
    parse: parse,
    components: [
      {
        name: 'raw',
        type: 'string',
        description: 'Unmodified value'
      }, {
        name: 'number',
        type: 'string',
        description: 'Street Number'
      }, {
        name: 'name',
        type: 'string',
        description: 'Street Name'
      }
    ],
    maskable: false,
    operators: ['is equal to', 'is not equal to', 'is blank', 'is not blank', 'format is valid', 'format is invalid', 'includes', 'does not include', 'is included in', 'is not included in', 'matches pattern', 'does not match pattern'],
    examples: ['4203 Guadalupe St', '00283 Ondricka Street', '0746 Monahan Islands', '73398 Tomas Club'].map(parse).map(normalize)
  };

}).call(this);
